!----------------------------------------------------------------------
! M A I N   D A T A   S T R U C T U R E
! For storing/manipulating arbitrary number of grid functions
! defined on an arbitrary number of distinct lattices.
! Non-parameter values stored in common block / com_gfuni0 /
! although common facility may not actually be used.
!----------------------------------------------------------------------
      integer         getnlat,   getlatid,  getrank,  getpshape,
     &                getshape,  getpcoord, getsize, getpbounds,
     &                getbounds, getlatcs
      external        getnlat,   getlatid,  getrank,  getpshape,
     &                getshape,  getpcoord, getsize, getpbounds,
     &                getbounds, getlatcs
      real*8          q(memsiz)
      common        / com_gfuni0 / q
      integer         maxrank
      parameter     ( maxrank = 5 )
      integer         sizelatcb
      parameter     ( sizelatcb = 3 + 4 * maxrank )
      integer         maxgfcn
      parameter     ( maxgfcn = 100 )
      integer         ngfcn
      common        / com_gfuni0 / ngfcn
      integer         maxptrs
      parameter     ( maxptrs = maxgfcn * (2 + sizelatcb) )
      integer         ptrs(maxptrs)
      common        / com_gfuni0 /  ptrs
      integer         nptrs
      common        / com_gfuni0 /  nptrs
